;
; 03_debounce
;
; Created: 2016-10-25
; Author: Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU=2000000

    .INCLUDE "board.inc"
	.INCLUDE "utils.inc"
	.INCLUDE "switch.inc"

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	; Initialize stack
	ldi r16, low(INTERNAL_SRAM_END)
	sts CPU_SPL, r16
	ldi r16, high(INTERNAL_SRAM_END)
	sts CPU_SPH, r16
	; Initialize LEDs
	ldi r16, LED0_PIN_bm | LED1_PIN_bm
	sts LED_PORT_OUT, r16
	sts LED_PORT_DIR, r16
	; Initialize push-buttons
	ldi r16, PORT_OPC_PULLUP_gc
	sts BUTTON0_PINCTRL, r16
	sts BUTTON1_PINCTRL, r16
	; Initialize debounce routine
    debouce_init

super_loop:

    ; Check switch 0
	switch_test 0
	breq switch1

    ; Toggle LED
 	lds r0, LED_PORT_OUT
	ldi r16, LED0_PIN_bm
	eor r0, r16
	sts LED_PORT_OUT, r0

switch1:
    ; Check switch 1
	switch_test 1
	breq super_loop

    ; Toggle LED
 	lds r0, LED_PORT_OUT
	ldi r16, LED1_PIN_bm
	eor r0, r16
	sts LED_PORT_OUT, r0

    rjmp super_loop

;***************************************************************************
;* SUBROUTINES *************************************************************
;***************************************************************************

    .INCLUDE "debounce.inc"

    