;
; 04_usart
;
; Created: 2016-10-31
; Author: Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU=2000000
    .INCLUDE "board.inc"

	; Data Segment
	.DSEG

buffer:
    .BYTE 1

	; Code Segment
	.CSEG

    ; Initialize USART pins
    lds r16, USB_USART_PORT_DIR
	ori r16, USB_USART_TX_PIN_bm            ; TX is output
	andi r16, ~USB_USART_RX_PIN_bm          ; RX is input
	sts USB_USART_PORT_DIR, r16

    ; Configure USART
	ldi r16, USART_CMODE_ASYNCHRONOUS_gc | USART_CHSIZE_8BIT_gc | USART_PMODE_DISABLED_gc
	sts USB_USART_MODULE_CTRLC, r16
	ldi r16, 11                             ; 115200 baud -> BSEL = 11
	sts USB_USART_MODULE_BAUDCTRLA, r16 
	ldi r16, -7<<USART_BSCALE_gp            ; 115200 baud -> BSCALE = -7
	sts USB_USART_MODULE_BAUDCTRLB, r16
	ldi r16, USART_RXEN_bm | USART_TXEN_bm
	sts USB_USART_MODULE_CTRLB, r16

superloop:
    lds r0, USB_USART_MODULE_STATUS
    sbrs r0, USART_RXCIF_bp
    rjmp superloop                          ; loop if no data available
	lds r0, USB_USART_MODULE_DATA
    sts buffer, r0
loop:
    lds r0, USB_USART_MODULE_STATUS
    sbrs r0, USART_DREIF_bp
    rjmp loop                               ; loop if data register not empty
	lds r0, buffer
    sts USB_USART_MODULE_DATA, r0
    rjmp superloop
