;
; 06_pwm
;
; Created: 2016-11-02
; Author : Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU=2000000

    .INCLUDE "board.inc"
    .INCLUDE "utils.inc"
	.INCLUDE "switch.inc"

    .EQU PWM_PER = 10000
    .EQU PWM_DUTY = PWM_PER / 2
    .EQU PWM_STEP = PWM_PER / 10

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	; Initialize stack
	ldi r16, low(INTERNAL_SRAM_END)
	sts CPU_SPL, r16
	ldi r16, high(INTERNAL_SRAM_END)
	sts CPU_SPH, r16

	; Initialize LEDs with inverted I/O enabled
	ldi r16, LED0_PIN_bm
	sts LED_PORT_DIR, r16
	ldi r16, PORT_INVEN_bm
	sts LED0_PINCTRL, r16

	; Initialize push-buttons
	ldi r16, PORT_OPC_PULLUP_gc
	sts BUTTON0_PINCTRL, r16
	sts BUTTON1_PINCTRL, r16

	; Initialize PWM
	ldi r16, TC_CLKSEL_DIV2_gc
	sts TCE0_CTRLA, r16
	ldi r16, TC0_CCAEN_bm | TC_WGMODE_SS_gc
	sts TCE0_CTRLB, r16
	ldi r16, LOW(PWM_DUTY)
	sts TCE0_CCA, r16
	ldi r16, HIGH(PWM_DUTY)
	sts TCE0_CCA+1, r16
	ldi r16, LOW(PWM_PER)
	sts TCE0_PER, r16
	ldi r16, HIGH(PWM_PER)
	sts TCE0_PER+1, r16

	; Initialize debounce routine
    debouce_init

super_loop:

    ; Check switch 0
	switch_test 0
	breq switch1

    ; IF (TCE0_CCA < PWM_PER-PWM_STEP) THEN TCE0_CCA += PWM_STEP
	lds r16, TCE0_CCA
	lds r17, TCE0_CCA+1
    cpi r16, LOW(PWM_PER-PWM_STEP+1)
    ldi r18, HIGH(PWM_PER-PWM_STEP+1)
    cpc r17, r18
	brge switch1

    subi r16, low(-PWM_STEP)
    sbci r17, high(-PWM_STEP)
	sts TCE0_CCA, r16
	sts TCE0_CCA+1, r17

switch1:
    ; Check switch 1
	switch_test 1
	breq super_loop

    ; IF (TCE0_CCA >= PWM_STEP) THEN TCE0_CCA -= PWM_STEP
	lds r16, TCE0_CCA
	lds r17, TCE0_CCA+1
    cpi r16, LOW(PWM_STEP)
    ldi r18, HIGH(PWM_STEP)
    cpc r17, r18
	brlt super_loop

    subi r16, low(PWM_STEP)
    sbci r17, high(PWM_STEP)
	sts TCE0_CCA, r16
	sts TCE0_CCA+1, r17

    rjmp super_loop

;***************************************************************************
;* SUBROUTINES *************************************************************
;***************************************************************************

    .INCLUDE "debounce.inc"
