;
; 07_adc
;
; Created: 2016-11-22
; Author : Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU=2000000

    .INCLUDE "board.inc"

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	; Initialize LEDs with inverted I/O enabled
	ldi r16, LED_PINS_gm
	sts LED_PORT_DIR, r16
	sts PORTCFG_MPCMASK, r16
	ldi r16, PORT_INVEN_bm
	sts LED0_PINCTRL, r16

	; Initialize light sensor
	ldi r16, LIGHT_SENSOR_SIGNAL_PIN_bm
	sts LIGHT_SENSOR_SIGNAL_PORT_DIRCLR, r16

	; Initialize ADC
	lds r16, LIGHT_SENSOR_ADC_CTRLA
	ori r16, ADC_ENABLE_bm
	sts LIGHT_SENSOR_ADC_CTRLA, r16
	ldi r16, ADC_RESOLUTION_12BIT_gc
	sts LIGHT_SENSOR_ADC_CTRLB, r16
	ldi r16, ADC_REFSEL_INT1V_gc | ADC_BANDGAP_bm
	sts LIGHT_SENSOR_ADC_REFCTRL, r16
	ldi r16, ADC_PRESCALER_DIV8_gc
	sts LIGHT_SENSOR_ADC_PRESCALER, r16

    ; Configure channel for light sensor
	ldi r16, ADC_CH_INPUTMODE_SINGLEENDED_gc
	sts LIGHT_SENSOR_ADC_CH0_CTRL, r16
	ldi r16, LIGHT_SENSOR_ADC_INPUT
	sts LIGHT_SENSOR_ADC_CH0_MUXCTRL, r16

superloop:
    ; Start conversion
	lds r16, LIGHT_SENSOR_ADC_CH0_CTRL
	ori r16, ADC_CH_START_bm
	sts LIGHT_SENSOR_ADC_CH0_CTRL, r16
loop:
	lds r16, LIGHT_SENSOR_ADC_CH0_INTFLAGS
	andi r16, ADC_CH_CHIF_bm
	breq loop
	; Read conversion results
    lds r16, LIGHT_SENSOR_ADC_CH0_RES
    lds r17, LIGHT_SENSOR_ADC_CH0_RES+1
    ; Display the upper 8 bits of the result
    lsr r17
	ror r16
    lsr r17
	ror r16
    lsr r17
	ror r16
    lsr r17
	ror r16
    sts LED_PORT_OUT, r16
    rjmp superloop
