;
; 08_spi
;
; Created: 2016-11-26
; Author : Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU = 2000000

    .INCLUDE "board.inc"
    .INCLUDE "utils.inc"

    .EQU SPI_PORT_DIRCLR = PORTF_DIRCLR
    .EQU SPI_PORT_DIRSET = PORTF_DIRSET
    .EQU SPI_PORT_OUTCLR = PORTF_OUTCLR
    .EQU SPI_PORT_OUTSET = PORTF_OUTSET
    .EQU SPI_MODULE_CTRL = SPIF_CTRL
    .EQU SPI_MODULE_DATA = SPIF_DATA
    .EQU SPI_MODULE_STATUS = SPIF_STATUS

    .EQU SPI_SS_bm = PIN4_bm
    .EQU SPI_MOSI_bm = PIN5_bm
    .EQU SPI_MISO_bm = PIN6_bm
    .EQU SPI_SCK_bm = PIN7_bm

    .EQU SPI_DATA = 'A'

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	// Initialize SPI
	ldi r16, SPI_MISO_bm
	sts SPI_PORT_DIRCLR, r16
	ldi r16, SPI_SS_bm | SPI_MOSI_bm | SPI_SCK_bm
	sts SPI_PORT_DIRSET, r16
	ldi r16, SPI_SS_bm
	sts SPI_PORT_OUTSET, r16
	ldi r16, SPI_ENABLE_bm | SPI_MASTER_bm | SPI_PRESCALER_DIV64_gc
	sts SPI_MODULE_CTRL, r16

superloop:

	; Select slave
	ldi r16, SPI_SS_bm
	sts SPI_PORT_OUTCLR, r16

	; Send data
	ldi r16, SPI_DATA
	sts SPI_MODULE_DATA, r16
loop:
	lds r16, SPI_MODULE_STATUS
	andi r16, SPI_IF_bm
	breq loop

	; Deselect slave
	ldi r16, SPI_SS_bm
	sts SPI_PORT_OUTSET, r16
	delay_ms 1000

    rjmp superloop

