;
; 09_twi
;
; Created: 2016-11-27
; Author : Wolfgang Neff
; Copyright: (CC) BY-NO-NO
;

    .EQU F_CPU = 2000000
    .EQU F_TWI = 100000

    .INCLUDE "board.inc"
    .INCLUDE "utils.inc"

    .EQU TWI_SDA_bm = PIN0_bm
    .EQU TWI_SCL_bm = PIN1_bm
    .EQU TWI_PORT_PIN0CTRL = PORTF_PIN0CTRL
    .EQU TWI_MODULE_MASTER_ADDR = TWIF_MASTER_ADDR
    .EQU TWI_MODULE_MASTER_BAUD = TWIF_MASTER_BAUD
    .EQU TWI_MODULE_MASTER_DATA = TWIF_MASTER_DATA
    .EQU TWI_MODULE_MASTER_CTRLA = TWIF_MASTER_CTRLA
    .EQU TWI_MODULE_MASTER_CTRLC = TWIF_MASTER_CTRLC
    .EQU TWI_MODULE_MASTER_STATUS = TWIF_MASTER_STATUS

    .EQU TWI_DATA = 'A'
    .EQU TWI_ADDRESS = 0x22

	; Data Segment
	.DSEG

	; Code Segment
	.CSEG

	// Enable internal pull-ups
	ldi r16, TWI_SDA_bm | TWI_SCL_bm
	sts PORTCFG_MPCMASK, r16
	lds r16, TWI_PORT_PIN0CTRL
	andi r16, ~PORT_OPC_gm
	ori r16, PORT_OPC_PULLUP_gc
	sts TWI_PORT_PIN0CTRL, r16

	// Initialize TWI
	ldi r16, TWI_MASTER_ENABLE_bm
	sts TWI_MODULE_MASTER_CTRLA, r16
	ldi r16, F_CPU/2/F_TWI - 5
	sts TWI_MODULE_MASTER_BAUD, r16
	ldi r16, TWI_MASTER_BUSSTATE_IDLE_gc
	sts TWI_MODULE_MASTER_STATUS, r16

superloop:

    ; Open write transmission
	ldi r16, TWI_ADDRESS
	lsl r16
	sts TWI_MODULE_MASTER_ADDR, r16
loop1:
	lds r16, TWI_MODULE_MASTER_STATUS
	andi r16, TWI_MASTER_WIF_bm
	breq loop1
	lds r16, TWI_MODULE_MASTER_STATUS
	ori r16, TWI_MASTER_WIF_bm
	sts TWI_MODULE_MASTER_STATUS, r16

	; Send data
	ldi r16, TWI_DATA
	sts TWI_MODULE_MASTER_DATA, r16
loop2:
	lds r16, TWI_MODULE_MASTER_STATUS
	andi r16, TWI_MASTER_WIF_bm
	breq loop2
	lds r16, TWI_MODULE_MASTER_STATUS
	ori r16, TWI_MASTER_WIF_bm
	sts TWI_MODULE_MASTER_STATUS, r16

	; Close transmission
	ldi r16, TWI_MASTER_ACKACT_bm | TWI_MASTER_CMD_STOP_gc
	sts TWI_MODULE_MASTER_CTRLC, r16

	delay_ms 1000

    rjmp superloop

